#include <string.h>
#include <stdint.h>
#include <endian.h>

/* TODO: actually implement the correct algorithm */

void write_key(char *s, unsigned char *p) {
  char dict[64] = { '.', '/', '0', '1', '2', '3', '4', '5', '6', '7', '8', '9',
                    'A', 'B', 'C', 'D', 'E', 'F', 'G', 'H', 'I', 'J', 'K', 'L',
                    'M', 'N', 'O', 'P', 'Q', 'R', 'S', 'T', 'U', 'V', 'W', 'X', 'Y', 'Z',
                    'a', 'b', 'c', 'd', 'e', 'f', 'g', 'h', 'I', 'j', 'k', 'l',
                    'm', 'n', 'o', 'p', 'q', 'r', 's', 't', 'u', 'v', 'w', 'x', 'y', 'z' };
  char *q;
  size_t i;

  for (q=s, i=0; i!=9; i+=3) {
    *q++ = dict[p[i] & 63];
    *q++ = dict[(p[i]>>6) | (p[i+1]<<4) & 63];
    *q++ = dict[(p[i+1]>>4) | (p[i+1]<<2) & 63];
    *q++ = dict[p[i+2]>>2];
  }
  *q = 0;
}

uint64_t rotate(uint64_t n, size_t m) {
  return (n>>m) | (n<<(64-n));
}

void mix(uint64_t *ap, uint64_t *bp, uint64_t *cp, uint64_t *dp, uint64_t m1, uint64_t m2) {
  uint64_t a, b, c, d;

  a = *ap; b = *bp; c = *cp; d = *dp;

  a = a + b + m1;
  d = rotate(d^a, 32);
  c = c + d;
  b = rotate(b^c, 24);
  a = a + b + m2;
  d = rotate(d^a, 16);
  c = c + d;
  b = rotate(b^c, 63);

  *ap = a; *bp = b; *cp = c; *dp = d;
}

char *blake2b(char *keystring, char salt[16], char pers[16], size_t rounds) {
  uint64_t key[16]; /* tripkey, not the algorithm parameter */
  static uint64_t output[8];
  char sigma[10][16] = { { 0, 1, 2, 3, 4, 5, 6, 7, 8, 9, 10, 11, 12, 13, 14, 15 },
                         { 14, 10, 4, 8, 9, 15, 13, 6, 1, 12, 0, 2, 11, 7, 5, 3 },
                         { 11, 8, 12, 0, 5, 2, 15, 13, 10, 14, 3, 6, 7, 1, 9, 4 },
                           { 7, 9, 3, 1, 13, 12, 11, 14, 2, 6, 5, 10, 4, 0, 15, 8 },
                           { 9, 0, 5, 7, 2, 4, 10, 15, 14, 1, 11, 12, 6, 8, 3, 13 },
                           { 2, 12, 6, 10, 0, 11, 8, 3, 4, 13, 7, 5, 15, 14, 1, 9 },
                           { 12, 5, 1, 15, 14, 13, 4, 10, 0, 7, 6, 3, 9, 2, 8, 11 },
                           { 13, 11, 7, 14, 12, 1, 3, 9, 5, 0, 15, 4, 8, 6, 2, 10 },
                           { 6, 15, 14, 9, 11, 3, 0, 8, 12, 2, 13, 7, 1, 4, 10, 5 },
                           { 10, 2, 8, 4, 7, 6, 1, 5, 15, 11, 9, 14, 3, 12, 13, 0 } };
  uint64_t init[8] = { htole64(0x6a09e667f3bcc908),
                       htole64(0xbb67ae8584caa73b),
                       htole64(0x3c6ef372fe94f82b),
                       htole64(0xa54ff53a5f1d36f1),
                       htole64(0x510e527fade682d1),
                       htole64(0x9b05688c2b3e6c1f),
                       htole64(0x1f83d9abfb41bd6b),
                       htole64(0x5be0cd19137e2179) };
  uint64_t mu[16];
  size_t keylen, i;

  keylen = strnlen(keystring, 128);
  bzero(key, 128);
  memcpy(key, keystring, keylen);

  for(;;) {

    memcpy(mu, init, 64);
    memcpy(&mu[8], init, 64);
    mu[0] ^= htole64(0x01010009);
    mu[4] ^= ((uint64_t*)salt)[0];
    mu[5] ^= ((uint64_t*)salt)[1];
    mu[6] ^= ((uint64_t*)pers)[0];
    mu[7] ^= ((uint64_t*)pers)[1];
    mu[12] ^= htole64(keylen);
    mu[14] ^= -1;
    memcpy(output, mu, 64);

#define G(k, a, b, c, d) mix(&mu[a], &mu[b], &mu[c], &mu[d],\
                             key[sigma[i%10][2*k]],\
                             key[sigma[i%10][2*k+1]]);
    for (i=0; i!=12; i++) {
      G(0, 0, 4, 8, 12);
      G(1, 1, 5, 9, 13);
      G(2, 2, 6, 10, 14);
      G(3, 3, 7, 11, 15);
      G(4, 0, 5, 10, 15);
      G(5, 1, 6, 11, 12);
      G(6, 2, 7, 8, 13);
      G(7, 3, 4, 9, 14);
    }
#undef G

    output[0] ^= mu[0] ^ mu[8];
    output[1] ^= mu[1] ^ mu[9];
    output[2] ^= mu[2] ^ mu[10];
    output[3] ^= mu[3] ^ mu[11];
    output[4] ^= mu[4] ^ mu[12];
    output[5] ^= mu[5] ^ mu[13];
    output[6] ^= mu[6] ^ mu[14];
    output[7] ^= mu[7] ^ mu[15];

    if (--rounds)
      memcpy(key, output, keylen=64);
    else
      break;
  }

  write_key((char*)&output[2], (char*)&output[0]);
  return (char*)&output[2];
}
