#include <unistd.h>

#define hex(v) ((v) >= '0' && (v) <= '9' || (v) >= 'A' && (v) <= 'F')
char hexbyte(char *p) {
  char i;

  if (p[0] >= '0' && p[0] <= '9')
    i = p[0] - '0';
  else if (p[0] >= 'A' && p[0] <= 'F')
    i = p[0] + 10 - 'A';
  else
    return 0;
  i *= 16;

  if (p[1] >= '0' && p[1] <= '9')
    i += p[1] - '0';
  else if (p[1] >= 'A' && p[1] <= 'F')
    i += p[1] + 10 - 'A';
  else
    return 0;

  return i;
}
#undef hex

void urldecode(char *s) {
  char *p;
  size_t n;
  char c;

  p = s;
  n = 0;
  while (c = *p++) {
    if (c == '+') {
      write(1, s+n, p-s-n-1);
      write(1, " ", 1);
      n = p-s;
    }
    else if (c == '%') {
      c = hexbyte(p);
      if (!c) /* never send null bytes */
        continue;
      write(1, s+n, p-s-n-1);
      write(1, &c, 1);
      p += 2;
      n = p-s;
    }
    else
      continue;
  }
  write(1, s+n, p-s-n-1);
}

int main(int argc, char **argv) {
  int i;

  for (i=1; i!=argc; i++) {
    urldecode(argv[i]);
    write(1, "", 1);
  }
}
