#include <stdlib.h>
#include <fcntl.h>
#include <string.h>
#include <unistd.h>
#include <time.h>
#include <sys/wait.h>
#include <sys/types.h>
#include <dirent.h>

#include "io.h"

int main(int argc, char **argv, char **envp) {
  struct s_threadlist list[THREAD_LIMIT+2];
  char id[READ_BUFFER_SIZE];
  DIR *dir;
  char *call[4] = { ZBBS_BIN "/zbbs-unthread", NULL, NULL, NULL };
  int board, thread, out;
  size_t n, i, oldest;

  if (argc != 2)
    fail("Usage: zbbs-post board\n");
  if (strchr(argv[1], '/'))
    fail("Invalid character in board name.\n");

  board = open(argv[1], O_RDONLY|O_DIRECTORY);
  if (board == -1 || access(argv[1], W_OK)) /* confirm writable */
    fail("Board does not exist.\n");

  while (getprop(board, "wait"))
    sleep_on(board, "wait");

  dir = opendir(argv[1]);
  bzero(list, sizeof(list));
  n = read_threads(dir, board, &list[0], THREAD_LIMIT+2);
  closedir(dir);
  if (n > THREAD_LIMIT) {
    if (!fork()) {
      oldest = 0;
      for (i=1; i!=THREAD_LIMIT; i++)
        if (bumpcmp(&list[oldest], &list[i]) < 0)
          oldest = i;
      call[1] = argv[1];
      call[2] = &list[oldest].id[0];
      execve(call[0], call, envp);
    }
    if (n == THREAD_LIMIT+2)
      goto release; /* let the next process continue */
  }

  qsort(list, n, sizeof(struct s_threadlist), &bumpcmp);
  out = openat(board, "index.html", O_WRONLY|O_CREAT|O_TRUNC, 0666);
  write_header(out, NULL, argv[1], 1);
  write_board(out, board, argv[1], &list[0], n);
  write_footer(out);

  close(out);
  writestr(2, "updated board ");
  write(2, argv[1], strlen(argv[1]));
  writestr(2, "\n");
  release:
  unlinkat(board, "wait", 0);
  close(board);
  exit(0);
  return 0;
}
