#include <stdlib.h>
#include <string.h>
#include <fcntl.h>
#include <unistd.h>
#include <dirent.h>

#include "io.h"

void migrate(int fd, ssize_t diff) {
  seek_footer(fd);
  lseek(fd, -diff, SEEK_CUR);
  write_footer(fd);
  ftruncate(fd, lseek(fd, 0, SEEK_CUR));
}

int main(int argc, char **argv) {
  struct s_threadlist list[THREAD_LIMIT];
  DIR *dir;
  int i, board, thread, fd;
  ssize_t diff;
  size_t n, j;

  if (argc < 3)
    fail("Usage: zbbs-migrate old board [..]\n");

  diff = strlen(argv[1]) - strlen(ZBBS_VERSION);

  for (i=2; i!=argc; i++) {
    board = open(argv[i], O_DIRECTORY|O_RDONLY);
    if (board == -1 || access(argv[i], W_OK)) {
      writestr(1, "Board ");
      write(1, argv[i], strlen(argv[i]));
      writestr(1, " does not exist.\n");
      exit(1);
    }
    dir = fdopendir(dup(board));
    n = read_threads(dir, board, &list[0], THREAD_LIMIT);
    closedir(dir);
    for (j=0; j!=n; j++) {
      thread = openat(board, list[j].id, O_DIRECTORY|O_RDONLY);
      if (thread == -1)
        writestr(1, "failed to migrate ");
      else {
        fd = openat(thread, "index.html", O_WRONLY);
        if (fd == -1)
          writestr(1, "failed to migrate ");
        else {
          migrate(fd, diff);
          writestr(1, "migrated ");
        }
      }
      write(1, argv[i], strlen(argv[i]));
      writestr(1, "/");
      write(1, list[j].id, strlen(list[j].id));
      writestr(1, "\n");
    }
  }
}
