#include <stdlib.h>
#include <fcntl.h>
#include <string.h>
#include <unistd.h>
#include <time.h>
#include <stdio.h>
#include <sys/stat.h>

#include "io.h"

int main(int argc, char **argv, char **envp) {
  char id[READ_BUFFER_SIZE];
  char *title, *name, *mail;
  int board, thread, out, noupdate;
  size_t n;

  noupdate = 0;

  if (argc != 7)
    fail("Usage: zbbs-post board thread name mail subject comment\n");
  if (strchr(argv[1], '/'))
    fail("Invalid character in board name.\n");
  if (strchr(argv[2], '/'))
    fail("Invalid character in thread name.\n");
  if (!argv[6][0])
    fail("Post empty.\n");
  name = (argv[3][0])?argv[3]:"Anonymous";
  mail = (argv[4][0])?argv[4]:NULL;

  board = open(argv[1], O_RDONLY|O_DIRECTORY);
  if (board == -1 || access(argv[1], W_OK)) /* confirm writable */
    fail("Board does not exist.\n");
  if (getprop(board, "lock"))
    fail("Board is locked.\n");
  while (getprop(board, "wait"))
    sleep_on(board, "wait");

  thread = openat(board, argv[2], O_DIRECTORY|O_RDONLY);
  if (thread == -1 || faccessat(board, argv[2], W_OK, AT_SYMLINK_NOFOLLOW))
    fail("Thread does not exist.\n");
  if (getprop(thread, "lock"))
    fail("Thread is locked.\n");

  n = read_count(thread, id, 1);
  id[n] = 0;
  out = openat(thread, "index.html", O_WRONLY);
  seek_footer(out);
  write_post(out, id, name, argv[5], mail, argv[6]);
  write_footer(out);

  if (strcmp("sage", argv[4]) && !getprop(thread, "sage")) {
    utimensat(thread, "bump", NULL, AT_SYMLINK_NOFOLLOW);
    if (!getprop(thread, "zap") && !fork()) {
      argv[0] = ZBBS_BIN "/zbbs-board";
      argv[2] = 0; /* pass board */
      execve(argv[0], argv, envp);
    }
  }
  renameat(thread, "wait", thread, "count");
  close(out);
  close(thread);
  close(board);
  id[n] = '\n';
  write(1, id, n+1);
  writestr(2, "new post ");
  write(2, argv[1], strlen(argv[1]));
  writestr(2, "/");
  write(2, argv[2], strlen(argv[2]));
  writestr(2, "#");
  write(2, id, n+1);
  exit(0);
  return 0;
}
